import json
import copy

import constants as Constants

class Exploit(object):
    """ Exploit object
    Consists of {source, URL} fields
    """
    def __init__(self, exploit_json):
        self.__exploit_json = exploit_json
        self.__source = self.__exploit_json[Constants.VULN_EXPLOIT_SOURCE]
        self.__url = self.__exploit_json[Constants.VULN_EXPLOIT_URL]

    def get_source(self):
        """
        :Returns the source of the exploit
        """
        return self.__source

    def get_url(self):
        """
        :Returns the URL for the exploit
        """
        return self.__url

    def to_json(self):
        """
        :Returns JSON representation of the object
        """
        return copy.deepcopy(self.__exploit_json)

    def __str__(self):
        return json.dumps(self.__exploit_json)

    def __repr__(self):
        return json.dumps(self.__exploit_json)


def json2exploits(exploits_json):
    exploits = []
    for e in exploits_json:
        exploits.append(Exploit(e))
    return exploits

